using System;
using System.Windows.Forms;
using Office = Microsoft.Office.Core;
using Excel = Microsoft.Office.Interop.Excel;
using MSForms = Microsoft.Vbe.Interop.Forms;

// Office łB[NubÑX^[gAbv NXʂ܂BύXȂłB
[assembly:System.ComponentModel.DescriptionAttribute("OfficeStartupClass, Version=1.0, Class=ExcelProject1.OfficeCodeBehind")]

namespace ExcelProject1
{
    /// <summary>
    /// [NubÑ}l[W R[hg܂ł܂B
    /// </summary>
    public class OfficeCodeBehind
    {
        
        /// <summary>
        /// AvP[V IuWFNgłB
        /// </summary>
        internal Excel.Application ThisApplication
        {
            get { return thisApplication;}
        }

        /// <summary>
        /// [NubN IuWFNgłB
        /// </summary>
        internal Excel.Workbook ThisWorkbook
        {
            get { return thisWorkbook;}
        }

        private Excel.Application thisApplication = null;
        private Excel.Workbook thisWorkbook = null;

        private Excel.WorkbookEvents_OpenEventHandler openEvent;
        private Excel.WorkbookEvents_BeforeCloseEventHandler beforeCloseEvent;

		/// <summary>
		/// j[ o[{
		/// </summary>
		private Office.CommandBar mainMenuBar = null;
		/// <summary>
		/// j[ o[{̂ɕ\郁j[ځij[ڂ̃Xg\邽߂̃Rg[j
		/// </summary>
		private Office.CommandBarControl mainMenuItem = null;
		/// <summary>
		/// j[ Xgɕ\郁j[
		/// </summary>
		private Office.CommandBarButton menuListItem = null;
		
		#region ꂽR[h

        /// <summary>
        /// ̃RXgN^łB
        /// </summary>
        public OfficeCodeBehind()
        {
        }

        /// <summary>
        /// KvȃvV[WłBύXȂłB
        /// </summary>
        /// <param name="application">AvP[V IuWFNgłB</param>
        /// <param name="workbook">[NubN IuWFNgłB</param>
        public void _Startup(object application, object workbook)
        {
            this.thisApplication = application as Excel.Application;
            this.thisWorkbook = workbook as Excel.Workbook;

            openEvent= new Excel.WorkbookEvents_OpenEventHandler (ThisWorkbook_Open);
            thisWorkbook.Open += openEvent;
            
            beforeCloseEvent = new Excel.WorkbookEvents_BeforeCloseEventHandler(ThisWorkbook_BeforeClose);
            thisWorkbook.BeforeClose += beforeCloseEvent;
        }

        /// <summary>
        /// KvȃvV[WłBύXȂłB
        /// </summary>
        public void _Shutdown()
        {
            thisApplication = null;
            thisWorkbook = null;
        }

        /// <summary>
        /// w肳ꂽÕRg[ANeBuȃ[NV[gŌ܂B
        /// </summary>
        /// <param name='name'>Rg[łB</param>
        /// <returns>
        /// w肳ꂽRg[A܂͌Ȃꍇɂ Null Ԃ܂B
        /// </returns>
        object FindControl(string name )
        {
            return FindControl(name, (Excel.Worksheet) ThisWorkbook.ActiveSheet);
        }

        /// <summary>
        /// w肳ꂽ[NV[gɎw肳ꂽÕRg[Ԃ܂B
        /// </summary>
        /// <param name='name'>Rg[łB</param>
        /// <param name='sheet'>Rg[܂ރ[NV[g IuWFNgłB</param>
        /// <returns>
        /// w肳ꂽRg[A܂͌Ȃꍇɂ Null Ԃ܂B
        /// </returns>
        object FindControl(string name, Excel.Worksheet sheet ) 
        {
            Excel.OLEObject theObject;
            try
            {
                theObject = (Excel.OLEObject) sheet.OLEObjects(name);
                return theObject.Object;
            }
            catch
            {
                // Rg[Ȃꍇ Null Ԃ܂B
            }
            return null;
        }

        #endregion

        /// <summary>
        /// [NubNJꂽƂɌĂяo܂B
        /// </summary>
        protected void ThisWorkbook_Open()
        {
			Excel.Worksheet sheet1 = (Excel.Worksheet)this.ThisApplication.Sheets.get_Item(1);  // @
			((Excel.Range)sheet1.Cells[1,1]).Value2 ="Hello World!";  // A

			// ***** ȉ̃R[h͋Lɂ͌fڂĂ܂ ***** 

			// C j[ o[ij[ o[̎w菈jB
			this.mainMenuBar = InitMainMenuBar();
			if (this.mainMenuBar == null)
			{
				return;	// G[IG[̓\bhŕ\ς݁B
			}

			// C j[ɁuTravel toolsvƂڂ쐬B
			// ...Ȃ݂ɕ̑OɁu&vƂ̕uAlt+ṽV[gJbgL[ɂȂB
			this.mainMenuItem = CreateMenuBarItem(
				(Office.CommandBar)this.mainMenuBar, "&Travel tools");
			if (this.mainMenuItem == null) 
			{
				return;	// G[IG[̓\bhŕ\ς݁B
			}

			// j[ځuTravel toolsvNbNꂽƂɕ\郁j[ Xg̍ڂ쐬B
			this.menuListItem = CreateMenuListItem(
				(Office.CommandBarPopup)this.mainMenuItem, "&Create Expense Report");
			if (this.menuListItem == null) 
			{
				return;	// G[IG[̓\bhŕ\ς݁B
			}

			// j[ڂNbNꂽƂ̏\bho^B
			this.menuListItem.Click += 
				new Office._CommandBarButtonEvents_ClickEventHandler(MenuListItem_Click);

			// GNZV[gɏݏ
			WriteStringToCell("B1", "Insider.NET");

			// `[g쐬
			CreateChart();

			// [U[ID\
			ShowUserID();
        }

        /// <summary>
        /// [NubNOɌĂяo܂B̃\bh
        /// Ăяo邱ƂACancel Ɋ蓖ĂꂽĺA
        /// ق̃R[h⃆[U[ꍇɂ͖\܂B
        /// </summary>
        /// <param name="Cancel">CxgƂ False Ԃ܂BCxg vV[Wɂ
        /// True ɐݒ肳ꂽꍇAvV[WsꂽƂɃhLg͕܂B
        /// </param>
        protected void ThisWorkbook_BeforeClose(ref bool Cancel)
        {
            Cancel = false;
        }

		/// <summary>
		/// C j[ o[̏
		/// </summary>
		/// <returns>擾j[o[BsꍇnullԂ</returns>
		private Office.CommandBar InitMainMenuBar()
		{
			Office.CommandBar cmdBar = null;
			try 
			{
				cmdBar = thisApplication.CommandBars["Worksheet Menu Bar"];
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message, ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
				return null;
			}
			return cmdBar;
		}

		/// <summary>
		/// j[o[ɕ\鍀1쐬B
		/// </summary>
		/// <param name="parentBar">j[ڂ̐eo[</param>
		/// <param name="strCaption">ږ</param>
		/// <returns>쐬j[ځBsꍇnullԂ</returns>
		private Office.CommandBarControl CreateMenuBarItem(Office.CommandBar parentBar, string strCaption)
		{
			Office.CommandBarControl cmdItem = null;
			try 
			{
				cmdItem = (Office.CommandBarControl)parentBar.Controls.Add(
					Office.MsoControlType.msoControlPopup, Type.Missing, Type.Missing, Type.Missing, true);
				cmdItem.Caption = strCaption;
				cmdItem.Visible = true;
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message, ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
				return null;
			}
			return cmdItem;
		}

		/// <summary>
		/// j[ڂ̃Xgɕ\鍀1쐬B
		/// </summary>
		/// <param name="parentItem">j[ڂ̐eACe</param>
		/// <param name="strCaption">ږ</param>
		/// <returns>쐬j[ځBsꍇnullԂ</returns>
		private Office.CommandBarButton CreateMenuListItem(Office.CommandBarPopup parentItem, string strCaption)
		{
			Office.CommandBarButton cmdItem = null;
			try 
			{
				cmdItem = (Office.CommandBarButton)parentItem.Controls.Add(
					Office.MsoControlType.msoControlButton, Type.Missing, Type.Missing, Type.Missing, true);
				cmdItem.Caption = strCaption;
				cmdItem.Visible = true;
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message, ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
				return null;
			}
			return cmdItem;
		}

		/// <summary>
		/// j[ Xg̍ڂNbNꂽƂ̃Cxg nhB
		/// </summary>
		/// <param name="ctrlItem">NbNꂽ</param>
		/// <param name="cancelDefault">LZftHgɂ邩ǂ</param>
		private void MenuListItem_Click(Office.CommandBarButton ctrlItem, ref bool cancelDefault)
		{
			MessageBox.Show("j[ڃNbN");
		}

		/// <summary>
		/// Zւ̕ށB
		/// </summary>
		/// <param name="strText">ޕ</param>
		public void WriteStringToCell(int x, int y, string strText)
		{
			Excel.Worksheet sheet1 = (Excel.Worksheet)this.ThisApplication.Sheets.get_Item(1);
			Excel.Range rangeA1 = (Excel.Range)sheet1.Cells[x,y];
			rangeA1.Value2 = strText;
		}

		/// <summary>
		/// Zւ̕ށB
		/// </summary>
		/// <param name="strText">ޕ</param>
		public void WriteStringToCell(string strCellID, string strText)
		{
			Excel.Worksheet sheet1 = (Excel.Worksheet)this.thisWorkbook.Worksheets.get_Item("Sheet1");
			Excel.Range rangeA1 = sheet1.get_Range(strCellID, Type.Missing);
			rangeA1.Value2 = strText;
		}

		/// <summary>
		/// `[g쐬B
		/// </summary>
		public void CreateChart()
		{
			Excel.Worksheet thisWorksheet = (Excel.Worksheet)this.thisWorkbook.ActiveSheet;
			Excel.ChartObjects charts = (Excel.ChartObjects)thisWorksheet.ChartObjects(Type.Missing);

			// Adds a chart at x = 100, y = 300, 500 points wide and 300 tall.
			Excel.ChartObject chartObj = charts.Add(100, 100, 500, 300);
			Excel.Chart chart = chartObj.Chart;

			// Gets the cells that define the bounds of the data to be charted.
			Excel.Range chartRange = thisWorksheet.get_Range("A5","D8");
			chart.SetSourceData(chartRange,Type.Missing);

			chart.ChartType = Excel.XlChartType.xlXYScatter;
			Excel.SeriesCollection seriesCollection= 
				(Excel.SeriesCollection)chart.SeriesCollection(Type.Missing);
			Excel.Series series = seriesCollection.Item(seriesCollection.Count);
		}

		/// <summary>
		/// ݂̃OI[U[ID\B
		/// </summary>
		private void ShowUserID()
		{
			Excel.Worksheet thisWorksheet = (Excel.Worksheet)this.thisWorkbook.ActiveSheet;
			Excel.Range userID = thisWorksheet.get_Range("UserID", Type.Missing);
			System.Security.Principal.WindowsIdentity user = 
				System.Security.Principal.WindowsIdentity.GetCurrent();
			userID.Value2 = user.Name;
		}
	}
}
